//#include "TareaParser.h"
#include <iostream.h>

// CLC.cpp  (C) adolfo@di-mare.com

// Tarea 3 Mauricio Ulate Felipe Umaa


/*  resultado
    Evala expresiones aritmticas simples en que los
    operandos son nmeros del 0 al 9.
*/



#include "Astring.h"       // class string

#include <iostream.h>
#include <cctype>

//	Modificacin
#include "Token.h"
#include "Arbol.h"
//	Fin Modificacin 

Token Nuevo_yylex();





class Calculadora {
public:
    //Calculadora(const char* exp=0)    : _estado(' '), _extractor(exp)  { Trabaje(); }
	//void operator = (const char* exp) { Trabaje(); }
    
	void	Analizar()	{ Trabaje(); }
	double Evaluar();
                        //  expr ==>   term r1
private:                //  r1   ==> + term r1
    void expr();        //  r1   ==> - term r1 | 
    void r1();          //
    void term();        //  term ==>   factor r2
    void r2();          //  r2   ==> * factor r2 | 
    void factor();      //  r2   ==> / factor r2
    void num();         //
                        //  factor ==> ( expr ) | num
                        //
    void aparea(Token); //  num ==> 0 | 1 | 2 | 3 | 4 | 5 | 6 | 7 | 8 | 9
    void Trabaje();
    void error(const char * msg);

private:
    Token  preAnalisis; // siguiente token

	Arbol	_Sintactico;
	char	_estado;

    size_t  _cursor;    // posicin en _infijo
};  // Calculadora


void Calculadora::Trabaje() {
/*  resultado
    Traduce a notacin posfija la exrpesin almancenada
    en *this.
    - Para evaluarla, hay que invocar a Calculadora::Evaluar().
*/
/*  requiere
    - La expresin almacenada no debe tener errores de sintaxis.
*/

    _Sintactico.LimpiarArbol();


	aparea(preAnalisis);
	expr();      // reconocer la expresin _infijo

	cout << "\n\nArbol:\n" << _Sintactico << endl;


} // Calculadora::Trabaje()

void Calculadora::error(const char * msg) {
/*  resultado
    Graba en "cout" un mensaje de error.
    - Indica la posicin actual de proceso en al hilera de entrada.
*/
    cout << "\nError " << 1+_cursor << "  ";
    if (msg != 0) {  // +1 porque _cursor comienza en 0
        if (msg[0] != 0) {
            cout << ":   " << msg;
        }
    }
    cout << endl;

	exit(1);
} // Calculadora::error()

void Calculadora::expr() {
//  expr ==> term r1
    term();
    r1();
} // Calculadora::expr()

void Calculadora::r1() {
//  r1 ==> + term r1
//  r1 ==> - term r1
//  r1 ==> 

	Token temp = preAnalisis;

    if (preAnalisis.Nombre() == "OP_SUM") {              //  r1 ==> + term r1
        aparea(preAnalisis);
        term(); {{ _Sintactico.Insertar(temp); }}
        r1();
    } 
    
    
} // Calculadora::r1()

void Calculadora::term() {
//  term ==> factor r2
    factor();
    r2();
} // Calculadora::term()

void Calculadora::r2() {
//  r2 ==> * factor r2
//  r2 ==> / factor r2
//  r2 ==> 

	Token temp = preAnalisis;

    if (preAnalisis.Nombre() == "OP_MUL") {              //  r2 ==> * factor r2
        aparea(preAnalisis);
        factor(); {{ _Sintactico.Insertar(temp); }}
        r2();
    } 
    
} // Calculadora::r2()

void Calculadora::factor() {
//  factor ==> ( expr )
//  factor ==>   num

    if (preAnalisis.Nombre() == "P_ABRE") {              //  factor ==> ( expr )
        aparea(preAnalisis);
        expr();
        aparea(preAnalisis);
    } else if (preAnalisis.Nombre() == "NUM") {     //  factor ==>   num
        {{ _Sintactico.Insertar(preAnalisis); }}
        aparea(preAnalisis);
    } else {
        error("El factor no es dgito ni '('");
    }
} // Calculadora::factor()


void Calculadora::aparea(Token ch) {
/*  resultado
    Consume el terminal, y avanza al siguiente lexema.
    - Si "ch" no coincide con el valor de "preAnalisis"
      emite un error.
*/

    if (preAnalisis.Nombre() != ch.Nombre()) {
        error("Token inesperado");
    }


	preAnalisis = Nuevo_yylex();


} // Calculadora::aparea()




double Calculadora::Evaluar() {
/*  resultado
    Evala la expresin contenida en "*this".
*/
 /*  resultado
    Evala la expresin contenida en "*this"
*/

	return _Sintactico.Evaluar();
}

int main() {

	Calculadora C;
    double        V;

	C.Analizar();
	V = C.Evaluar();
    
	cout << "Resultado: " << V << endl;

    return 0;
} // main()
